﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace _104129
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("1", typeof(string)).DefaultValue = "wekhuweriuhreiughweirughewirugheiwrugheirugheiurhgeirugh";
            dt.Rows.Add();
            dt.Rows.Add(); dt.Rows.Add(); dt.Rows.Add();

            ultraGrid1.DataSource = dt;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            bool hasTrunkedCell = false;
            int i = 0;
            while (i < ultraGrid1.Rows.Count  && !hasTrunkedCell)
            {   UltraGridRow row = ultraGrid1.Rows[i];
                i++;
                string text = row .Cells[0].Text;
                if(string.IsNullOrEmpty(text))
                    continue;
                Size cellsize = new System.Drawing.Size(row .Cells[0].Column .Width , row.Height );
                Size textsize = TextRenderer.MeasureText(text, GetFont(row.Cells[0]));
                
                hasTrunkedCell = (textsize.Height * textsize.Width * 1.22 >  cellsize.Height * cellsize.Width);
            }

            if (hasTrunkedCell)
                MessageBox.Show("There is a cell which text was trunked !");
            else
                MessageBox.Show("NONE!");
           
        }

        private Font GetFont(UltraGridCell ultraGridCell)
        {
            Infragistics.Win.AppearanceData appdata = new Infragistics.Win.AppearanceData();
            ultraGridCell.ResolveAppearance(ref appdata, Infragistics.Win.AppearancePropFlags.FontData| 
                Infragistics.Win.AppearancePropFlags.FontSize | Infragistics.Win.AppearancePropFlags.FontBold |
                Infragistics.Win.AppearancePropFlags.FontItalic | Infragistics.Win.AppearancePropFlags.FontName);
            
            FontStyle fs = FontStyle.Regular;
            if(appdata.FontData.Bold == Infragistics.Win.DefaultableBoolean.True )
                fs = fs |FontStyle.Bold;
           if(appdata.FontData.Italic  == Infragistics.Win.DefaultableBoolean.True )
                fs = fs |FontStyle.Italic;

           return GetFont(appdata.FontData);
        }

        private Font GetFont(Infragistics.Win.FontData fontData)
        {
            if (string.IsNullOrEmpty(fontData.Name))
                return new System.Drawing.Font("Arial", 9, FontStyle.Regular);
            
            FontStyle fs = FontStyle.Regular;
            if (fontData.Bold == Infragistics.Win.DefaultableBoolean.True)
                fs = fs | FontStyle.Bold;
            if (fontData.Italic == Infragistics.Win.DefaultableBoolean.True)
                fs = fs | FontStyle.Italic;

            return new Font(fontData.Name, fontData.SizeInPoints, fs);
        }
    }
}
